SystemOrganization addCategory: #'Pier-Google'!

!GRPackage class methodsFor: '*pier-google' stamp: 'lr 2/26/2010 23:09'!
pierGoogle
	^ self new
		name: 'Pier-Google';
		description: 'Adds Google analytics and webmaster tools to your pages.';
		addDependency: 'Pier-Model';
		addDependency: 'Pier-Seaside';
		url: #pierAddonsUrl;
		yourself! !

!PRViewRenderer methodsFor: '*pier-google-visiting' stamp: 'lr 1/5/2009 21:15'!
visitGoogleGadget: aStructure
	html script url: aStructure gadgetUrl! !

PRStructure subclass: #PRGoogleGadget
	instanceVariableNames: 'url xml translations settings description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Google'!

!PRGoogleGadget commentStamp: 'lr 1/5/2009 20:32' prior: 0!
Google Gadgets are simple HTML and JavaScript applications that can be embedded in webpages and other apps. Choose from thousands of Google Gadgets for your Pier installation from the Google Gadget Directory at http://www.google.com/ig/directory?synd=open.!

!PRGoogleGadget class methodsFor: 'testing' stamp: 'lr 1/5/2009 20:39'!
isAbstract
	^ false! !

!PRGoogleGadget class methodsFor: 'accessing' stamp: 'lr 1/8/2010 22:15'!
label
	^ 'Gadget'! !

!PRGoogleGadget methodsFor: 'visiting' stamp: 'lr 1/5/2009 20:39'!
accept: aVisitor
	aVisitor visitGoogleGadget: self! !

!PRGoogleGadget methodsFor: 'private' stamp: 'lr 6/14/2009 11:11'!
buildTranslation
	| result response elements |
	result := Dictionary new.
	xml tagsNamed: #'Locale' childrenDoAndRecurse: [ :locale |
		response := [ HTTPSocket httpGet: (locale attributeAt: 'messages' ifAbsent: [ nil ]) ]
			ifError: [ :err | nil ].
		(response isNil or: [ response isString ]) ifFalse: [
			elements := [ XMLDOMParser parseDocumentFrom: response ]
				ifError: [ :err | nil ].
			elements isNil ifFalse: [
				elements tagsNamed: #'msg' childrenDoAndRecurse: [ :msg |
					result
						at: (msg attributeAt: 'name' ifAbsent: [ '' ])
						put: (msg contentString) ].
				^ result ] ] ].
	^ result! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 1/6/2009 15:57'!
convertBoolPreference: anXmlElement
	^ MABooleanDescription new! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 3/23/2009 08:10'!
convertDefaultPreference: anXmlElement
	^ self convertStringPreference: anXmlElement! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 6/14/2009 10:21'!
convertEnumPreference: anXmlElement
	| options |
	options := OrderedCollection new.
	anXmlElement tagsNamed: #'EnumValue' 	childrenDoAndRecurse: [ :each |
		each attributes at: 'value' ifPresent: [ :value |
			options addLast: value -> (self translate: (each attributes
				at: 'display_value' ifAbsent: [ value ])) ] ].
	^ MASingleOptionDescription new
		optionsAndLabels: options;
		yourself! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'NickAger 1/24/2012 11:47'!
convertGenericPreference: anXmlElement
	| preference datatype |
	preference := nil.
	datatype := anXmlElement attributes at: 'datatype' ifAbsent: [ 'string' ].
	#( 'string' convertStringPreference: 'bool' convertBoolPreference: 'enum' convertEnumPreference: 'list' convertListPreference: 'hidden' convertHiddenPreference: ) pairsDo: [ :type :selector |
		(preference isNil and: [ datatype = type ])
			ifTrue: [ preference := self perform: selector with: anXmlElement ] ].
	preference isNil
		ifTrue: [ preference := self convertDefaultPreference: anXmlElement ].
	preference beSetting.
	preference group: 'User Preferences'.
	preference propertyAt: #xml put: anXmlElement.
	preference propertyAt: #urlparam put: (anXmlElement attributes 
		at: 'urlparam' ifAbsent: [ 'up_' , (anXmlElement attributes
		at: 'name' ifAbsent: [ ^ nil ]) ]).
	preference accessor: (anXmlElement attributes 
		at: 'name' ifAbsent: [ ^ nil ]) asSymbol.
	preference label: (self translate: (anXmlElement attributes 
		at: 'display_name' ifAbsent: [ anXmlElement attributes 
		at: 'name' ifAbsent: [ nil ] ])).
	anXmlElement attributes at: 'required' ifPresent: [ :value |
		value asLowercase = 'true'
			ifTrue: [ preference beRequired ] ].
	anXmlElement attributes at: 'default_value' ifPresent: [ :value |
		preference default: (preference fromString: value) ].
	^ self magritteDescription add: preference! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 3/23/2009 08:22'!
convertHiddenPreference: anXmlElement
	^ MAStringDescription new
		beHidden;
		yourself! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 1/6/2009 16:34'!
convertListPreference: anXmlElement
	^ nil! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 1/6/2009 15:54'!
convertStringPreference: anXmlElement
	^ MAStringDescription new! !

!PRGoogleGadget methodsFor: 'accessing-settings' stamp: 'NickAger 1/22/2012 17:11'!
descriptionBorder
	<magritteDescription>
	^ MAStringDescription new
		default: '#ffffff|3px,1px solid #999999';
		propertyAt: #urlparam put: 'border';
		group: 'Widget Preferences';
		accessor: #border;
		label: 'Border';
		priority: 2020;
		beSetting;
		yourself! !

!PRGoogleGadget methodsFor: 'accessing-settings' stamp: 'NickAger 1/22/2012 17:11'!
descriptionHeight
	<magritteDescription>
	^ MANumberDescription new
		propertyAt: #urlparam put: 'h';
		group: 'Widget Preferences';
		accessor: #height;
		label: 'Height';
		priority: 2010;
		default: 75;
		beSetting;
		yourself! !

!PRGoogleGadget methodsFor: 'accessing-editing' stamp: 'NickAger 1/22/2012 17:11'!
descriptionUrl
	<magritteDescription>
	^ MAStringDescription new
		label: 'Source URL';
		accessor: #url;
		priority: 200;
		beRequired;
		beEditable;
		yourself! !

!PRGoogleGadget methodsFor: 'accessing-editing' stamp: 'NickAger 1/22/2012 17:11'!
descriptionUrlComment
	<magritteDescription>
	^ MAMemoDescription new
		accessor: #urlComment;
		priority: 210;
		beReadonly;
		beEditable;
		label: '';
		yourself! !

!PRGoogleGadget methodsFor: 'accessing-settings' stamp: 'NickAger 1/22/2012 17:11'!
descriptionWidth
	<magritteDescription>
	^ MANumberDescription new
		propertyAt: #urlparam put: 'w';
		group: 'Widget Preferences';
		accessor: #width;
		priority: 2000;
		label: 'Width';
		default: 320;
		beSetting;
		yourself! !

!PRGoogleGadget methodsFor: 'accessing-dynamic' stamp: 'NickAger 1/24/2012 11:47'!
gadgetUrl
	| gadgetUrl |
	gadgetUrl := WAUrl new.
	gadgetUrl hostname: 'www.gmodules.com'; path: #('ig' 'ifr').
	self magritteDescription do: [ :desc |
		desc propertyAt: 'urlparam' ifPresent: [ :param |
			gadgetUrl addField: param value: (desc toString: (self readUsing: desc)) ] ].
	gadgetUrl addField: 'url' value: self url; addField: 'title' value: self title.
	gadgetUrl addField: 'synd' value: 'open'; addField: 'output' value: 'js'.
	^ gadgetUrl! !

!PRGoogleGadget methodsFor: 'acessing-magritte' stamp: 'NickAger 1/24/2012 11:45'!
magritteDescription
	^ description ifNil: [ description := super magritteDescription ]! !

!PRGoogleGadget methodsFor: 'private' stamp: 'lr 1/6/2009 16:17'!
readUsing: aDescription
	^ self settings
		at: (aDescription
			propertyAt: #urlparam
			ifAbsent: [ ^ super readUsing: aDescription ])
		ifAbsent: [ aDescription default ]! !

!PRGoogleGadget methodsFor: 'actions' stamp: 'NickAger 1/24/2012 11:46'!
refresh
	| response |
	xml := translations := description := nil.
	description := MAContainer withAll: self magritteDescription.
	response := [ HTTPSocket httpGet: self url ]
		ifError: [ :err | ^ self ].
	response isString 
		ifTrue: [ ^ self ].
	xml := [ XMLDOMParser parseDocumentFrom: response ]
		ifError: [ :err | ^ self ].
	xml 
		tagsNamed: #'UserPref'
		childrenDoAndRecurse: [ :each | self convertGenericPreference: each ]! !

!PRGoogleGadget methodsFor: 'accessing-dynamic' stamp: 'lr 1/6/2009 15:18'!
settings
	^ settings ifNil: [ settings := Dictionary new ]! !

!PRGoogleGadget methodsFor: 'translation' stamp: 'lr 6/14/2009 10:54'!
translate: aString
	"For now just translate by cropping the variable prefix, later on do the real thing: http://code.google.com/apis/gadgets/docs/i18n.html."

	| input output token |
	input := aString readStream.
	output := WriteStream on: String new.
	[ input atEnd ] whileFalse: [
		output nextPutAll: (input upToAll: '__MSG_').
		input atEnd ifFalse: [
			token := input upToAll: '__'.
			output nextPutAll: (self translations
				at: token
				ifAbsent: [ token copyReplaceAll: '_' with: ' ' ]) ] ].
	^ output contents! !

!PRGoogleGadget methodsFor: 'accessing-dynamic' stamp: 'lr 6/14/2009 10:51'!
translations
	^ translations ifNil: [ translations := self buildTranslation ]! !

!PRGoogleGadget methodsFor: 'accessing' stamp: 'lr 1/5/2009 20:35'!
url
	^ url! !

!PRGoogleGadget methodsFor: 'accessing' stamp: 'lr 1/6/2009 15:18'!
url: aString
	url := aString.
	self refresh
	


! !

!PRGoogleGadget methodsFor: 'accessing-dynamic' stamp: 'lr 1/5/2009 20:48'!
urlComment
	^ 'Choose from thousands of Google Gadgets for your Pier installation from the Google Gadget Directory at "http://www.google.com/ig/directory?synd=open". Select the Gadget you like and copy and paste the URL of the link "View Source" into the above input field.'! !

!PRGoogleGadget methodsFor: 'private' stamp: 'lr 1/6/2009 16:17'!
write: anObject using: aDescription
	^ self settings
		at: (aDescription
			propertyAt: #urlparam
			ifAbsent: [ ^ super write: anObject using: aDescription ])
		put: anObject! !

!PRVisitor methodsFor: '*pier-google-visiting' stamp: 'lr 1/5/2009 20:47'!
visitGoogleGadget: aStructure
	self visitStructure: aStructure! !

PRWidget subclass: #PRGoogleAnalyticsWidget
	instanceVariableNames: 'uacct onlyAnonymous onlyViews'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Google'!

!PRGoogleAnalyticsWidget class methodsFor: 'testing' stamp: 'lr 11/14/2007 19:49'!
isAbstract
	^ false! !

!PRGoogleAnalyticsWidget class methodsFor: 'accessing' stamp: 'tg 11/14/2007 13:01'!
label
	^ 'Google Analytics'! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 17:11'!
descriptionGoogleUACCT
	<magritteDescription>
	^ MAStringDescription new
		comment: 'The string Google Analytics provided you with (e.g. UA-XXXXXXX-Y)';
		parameterName: 'uacct';
		accessor: #uacct;
		label: 'uacct';
		priority: 200;
		beSetting;
		yourself! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 17:11'!
descriptionOnlyAnonymous
	<magritteDescription>
	^ MABooleanDescription new
		comment: 'Only include the widget if the user is anonymous';
		parameterName: 'only-anonymous';
		checkboxLabel: 'Anonymous User';
		accessor: #onlyAnonymous;
		default: false;
		priority: 220;
		beSetting;
		label: '';
		yourself! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 17:11'!
descriptionOnlyViews
	<magritteDescription>
	^ MABooleanDescription new
		comment: 'Only include the widget in views';
		parameterName: 'only-views';
		checkboxLabel: 'Views';
		accessor: #onlyViews;
		label: 'Display';
		default: true;
		priority: 210;
		beSetting;
		yourself! !

!PRGoogleAnalyticsWidget methodsFor: 'testing' stamp: 'lr 6/22/2009 13:23'!
isVisible

	" do not show if no ID is given "
	(self uacct isNil or: [ self uacct isEmpty ])
		ifTrue: [ ^ false ].

	" do not show if this is something else than a view "
	(self onlyViews and: [ self context command isView not ])
		ifTrue: [ ^ false ].

	" do not show if this user is logged in "
	(self onlyAnonymous and: [ (self context respondsTo: #isLoggedIn) and: [ self context isLoggedIn ] ])
		ifTrue: [ ^ false ].

	^ true! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 17:21'!
onlyAnonymous
	^ onlyAnonymous! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 17:21'!
onlyAnonymous: anObject
	onlyAnonymous := anObject! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 17:21'!
onlyViews
	^ onlyViews! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 17:21'!
onlyViews: anObject
	onlyViews := anObject! !

!PRGoogleAnalyticsWidget methodsFor: 'rendering' stamp: 'GastonDallOglio 6/27/2012 09:24'!
renderContentOn: html
	"This widget does not create any output in the HTML body."! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 17:21'!
uacct
	^ uacct! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 17:21'!
uacct: anObject
	uacct := anObject! !

!PRGoogleAnalyticsWidget methodsFor: 'updating' stamp: 'GastonDallOglio 6/27/2012 09:47'!
updateRoot: html
	super updateRoot: html.
	self isVisible ifFalse: [ ^ self ].
	html javascript add: 'var _gaq = _gaq || [];
_gaq.push(["_setAccount", "',  self uacct greaseString, '"]);
', "_gaq.push(['_setDomainName', 'domainName???']);"
'_gaq.push(["_trackPageview"]);

(function() {
  var ga = document.createElement("script"); ga.type = "text/javascript"; ga.async = true;
  ga.src = ("https:" == document.location.protocol ? "https://ssl" : "http://www") + ".google-analytics.com/ga.js";
  var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(ga, s);
})();'! !

PRWidget subclass: #PRWebmasterToolsWidget
	instanceVariableNames: 'verificationKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Google'!

!PRWebmasterToolsWidget commentStamp: 'pmm 3/24/2008 11:55' prior: 0!
A PRWebmasterToolsWidget is a widget that helps you to activate your site at Google Webmaster Tools.

https://www.google.com/webmasters/tools/docs/en/about.html

For maximum effect use it together with the Sitemap plugin.
!

!PRWebmasterToolsWidget class methodsFor: 'testing' stamp: 'pmm 3/24/2008 11:58'!
isAbstract
	^ false! !

!PRWebmasterToolsWidget class methodsFor: 'accessing' stamp: 'pmm 3/24/2008 12:00'!
label
	^ 'Google Webmaster Tools'! !

!PRWebmasterToolsWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/22/2012 17:12'!
descriptionVerificationKey
	<magritteDescription>
	^ MAStringDescription new
		comment: 'The Google Webmaster Tools Verification Key';
		selectorAccessor: #verificationKey;
		label: 'Verification Key';
		priority: 300;
		beSetting;
		yourself! !

!PRWebmasterToolsWidget methodsFor: 'rendering' stamp: 'lr 6/14/2009 09:56'!
renderContentOn: html
	"This widget does not create any output in the HTML body."! !

!PRWebmasterToolsWidget methodsFor: 'updating' stamp: 'lr 6/14/2009 09:55'!
updateRoot: html
	super updateRoot: html.
	self verificationKey isEmptyOrNil
		ifTrue: [ ^ self ].
	html meta
		name: 'verify-v1';
		content: self verificationKey! !

!PRWebmasterToolsWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 17:13'!
verificationKey
	^ verificationKey! !

!PRWebmasterToolsWidget methodsFor: 'accessing' stamp: 'NickAger 1/22/2012 17:13'!
verificationKey: anObject
	verificationKey := anObject! !
